jif.parse

## Class Wrapper

- java.lang.Object
- - polyglot.ast.Node_c
  - - polyglot.ast.Term_c
    - - polyglot.ast.Expr_c
      - - jif.parse.Wrapper

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, polyglot.ast.Expr, polyglot.ast.ExprOps, polyglot.ast.Node, polyglot.ast.NodeOps, polyglot.ast.Prefix, polyglot.ast.Receiver, polyglot.ast.Term, polyglot.ast.TermOps, polyglot.ast.Typed, polyglot.util.Copy<polyglot.ast.Node>

      public class Wrapper
      extends polyglot.ast.Expr_c

  A `Wrapper` wraps an `Amb` inside an AST node so that it can be insert in the AST. However, the tree must be visited by an `UnwrapVisitor` before it is returned from the parser, otherwise the other phases of the compiler will be unable to work with the tree!
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

    - ### Nested classes/interfaces inherited from interface polyglot.ast.Term

      `polyglot.ast.Term.Instance`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `Amb` | `amb`

    - ### Fields inherited from class polyglot.ast.Expr_c

      `type`

    - ### Fields inherited from class polyglot.ast.Term_c

      `exceptions, reachable`

    - ### Fields inherited from class polyglot.ast.Node_c

      `del, error, ext, position`

    - ### Fields inherited from interface polyglot.ast.Term

      `ENTRY, EXIT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Wrapper(Amb amb)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> java.util.List<T>` | `acceptCFG(polyglot.visit.CFGBuilder<?> v, java.util.List<T> succs)` Visit this term in evaluation order.
    `polyglot.ast.Term` | `firstChild()`
    `polyglot.ast.Node` | `visitChildren(polyglot.visit.NodeVisitor v)`

    - ### Methods inherited from class polyglot.ast.Expr_c

      `booleanValue, buildTypes, byteValue, charValue, constantValue, constantValue, constantValueSet, constantValueSet, doubleValue, dump, extRewrite, floatValue, intValue, isConstant, isConstant, isTypeChecked, lastLang, longValue, precedence, printSubExpr, printSubExpr, shortValue, stringValue, type, type, type`

    - ### Methods inherited from class polyglot.ast.Term_c

      `exceptionCheck, exceptions, exceptions, exceptions, listChild, reachable, reachable, reachable`

    - ### Methods inherited from class polyglot.ast.Node_c

      `addDecls, buildTypesEnter, checkConstants, childExpectedType, copy, copy, copy, copyIfNeeded, del, del, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, error, error, error, exceptionCheckEnter, ext, ext, ext, ext, extRewriteEnter, extRewriteOverride, isDisambiguated, lang, position, position, position, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, throwTypes, toString, translate, typeCheck, typeCheckEnter, typeCheckOverride, visit, visitChild, visitEdge, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface polyglot.ast.Node

      `del, del, error, error, ext, ext, ext, ext, isDisambiguated, position, position, visit, visitEdge`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitList`

    - ### Methods inherited from interface polyglot.util.Copy

      `copy`

    - ### Methods inherited from interface polyglot.ast.Term

      `exceptions, exceptions, reachable, reachable`

- - ### Field Detail

    - #### amb

          public Amb amb

  - ### Constructor Detail

    - #### Wrapper

          public Wrapper(Amb amb)

  - ### Method Detail

    - #### visitChildren

          public polyglot.ast.Node visitChildren(polyglot.visit.NodeVisitor v)

      Specified by:
        `visitChildren` in interface `polyglot.ast.NodeOps`
      Overrides:
        `visitChildren` in class `polyglot.ast.Node_c`

    - #### acceptCFG

          public <T> java.util.List<T> acceptCFG(polyglot.visit.CFGBuilder<?> v,
                                                 java.util.List<T> succs)

      Visit this term in evaluation order.
      Specified by:
        `acceptCFG` in interface `polyglot.ast.TermOps`
      Specified by:
        `acceptCFG` in class `polyglot.ast.Term_c`

    - #### firstChild

          public polyglot.ast.Term firstChild()

      Specified by:
        `firstChild` in interface `polyglot.ast.TermOps`
      Specified by:
        `firstChild` in class `polyglot.ast.Term_c`